Attribute VB_Name = "Module1"
Option Explicit

'Variable contenant l'adresse de la procdure Windows
Private AdressWinProc As Long

Private Const GWL_WNDPROC = (-4)
Private Const WM_GETMINMAXINFO = &H24
Private MinX As Single
Private MinY As Single

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Type MINMAXINFO
    ptReserved As POINTAPI
    ptMaxSize As POINTAPI
    ptMaxPosition As POINTAPI
    ptMinTrackSize As POINTAPI
    ptMaxTrackSize As POINTAPI
End Type

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long


Public Function MaWinProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim MinMax As MINMAXINFO
    
    'Intercepte le Message Windows de redimensionnement de fentre
    If uMsg = WM_GETMINMAXINFO Then
        CopyMemory MinMax, ByVal lParam, Len(MinMax)
        MinMax.ptMinTrackSize.x = MinX \ Screen.TwipsPerPixelX
        MinMax.ptMinTrackSize.y = MinY \ Screen.TwipsPerPixelY

        CopyMemory ByVal lParam, MinMax, Len(MinMax)
        'Code de retour pour signaler  Windows que le traitement s'est correctement effectu
        MaWinProc = 1
        Exit Function
    End If
    
    'Laisse les autres Messages  traiter  Windows
    MaWinProc = CallWindowProc(AdressWinProc, hWnd, uMsg, wParam, lParam)
End Function


Public Function LoadResizing(ByRef hWnd As Long, ByRef MinWidth As Single, ByRef MinHeight As Single)
    MinX = MinWidth
    MinY = MinHeight
    AdressWinProc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf MaWinProc)
End Function


Public Function RestoreResizing(ByRef hWnd As Long)
    Call SetWindowLong(hWnd, GWL_WNDPROC, AdressWinProc)
End Function
